<!DOCTYPE html>
<html>

<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>LAB MQTT timeline</title>

    <!-- MQTT.js -->
    <script src="https://unpkg.com/mqtt/dist/mqtt.min.js"></script>

    <!-- Materialize -->
    <!-- Compiled and minified CSS -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/css/materialize.min.css" />

    <!-- Materialize -->
    <!-- Compiled and minified JavaScript -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/js/materialize.min.js"></script>
    <link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">

    <!-- Vue.js -->
    <script src="https://unpkg.com/vue/dist/vue.min.js"></script>

    <!-- timeline CSS -->
    <link rel="stylesheet" href="css/timeline.css" />
</head>

<body>
    <script>



        console.log("started。。。。");

        console.log(mqtt)

        // Connection option
        const options = {
            clean: true, // Retain connection
            connectTimeout: 4000, // Timeout
            // Authtication
            clientId: 'mqttjs_' + Math.random().toString(16).substr(2, 8),
            username: 'fablabgsv@gmail.com',
            password: 'MQTT_TOKEN'
        }

        // Connection string
        // ws: unsecured WebSocket
        // wss: secured WebSocket connection
        // mqtt: unsecured TCP connection
        // mqtts: secured TCP connection
        const connectUrl = 'ws://maqiatto.com:8883'

        var client = mqtt.connect(connectUrl, options);

        client.on('connect', function () {
            console.log("connected。。。。");
            client.publish("fablabgsv@gmail.com/hello", "hello world!222");
            client.subscribe('fablabgsv@gmail.com/start', function (err) {
                if (!err) {
                    const badge = document.getElementById("connect-badge")
                    badge.innerText = "connected"
                    badge.classList.remove("orange")
                    badge.classList.add("green")
                }
            })
        })

        client.on('reconnect', (error) => {
            console.log('Reconnecting: ', error)
        })

        client.on('error', (error) => {
            console.log('Connection failed: ', error)
        })


        var data = {};
        data.messages = [];

        client.on('message', function (topic, payload) {
            var message = String.fromCharCode.apply(null, payload);
            console.log(message);
            data.messages.push(message);

            if(topic=='fablabgsv@gmail.com/start') {
                // ajout timeline event start
                document.getElementById("tl_conteneur").innerHTML += `<div class="timeline-event">
                <div class="card timeline-content">
                    <div class="card-image waves-effect waves-block waves-light">
                        <img class="activator" src="https://upload.wikimedia.org/wikipedia/commons/thumb/a/a7/Le_Mans_-_Cathedrale_St_Julien_ext_02.jpg/560px-Le_Mans_-_Cathedrale_St_Julien_ext_02.jpg">
                    </div>
                    <div class="card-content">
                        <span class="card-title activator grey-text text-darken-4 ">Départ<i class="material-icons">train</i></span>
                        <p>point de départ : Le Mans</p>
                    </div>
                    </div>
                    <div class="timeline-badge blue white-text"><i class="material-icons">language</i></div>
                </div>`;

                client.subscribe('fablabgsv@gmail.com/checkpoint1');
            }

            if(topic=='fablabgsv@gmail.com/checkpoint1') {
                // ajout timeline event start
                document.getElementById("tl_conteneur").innerHTML += `            <div class="timeline-event">
                <div class="card timeline-content">
                    <div class="card-image waves-effect waves-block waves-light">
                        <img class="activator" src="https://upload.wikimedia.org/wikipedia/commons/thumb/a/a6/Jielbeaumadier_tour_eiffel_paris_2007.jpg/440px-Jielbeaumadier_tour_eiffel_paris_2007.jpg">
                    </div>
                    <div class="card-content">
                        <span class="card-title activator grey-text text-darken-4">Escale<i
                                class="material-icons right">subway</i></span>
                        <p>escale : Paris</p>
                    </div>
                </div>
                <div class="timeline-badge red white-text"><i class="material-icons right">more_vert</i></div>
            </div>`;

                client.subscribe('fablabgsv@gmail.com/finish');
            }

            if(topic=='fablabgsv@gmail.com/finish') {
                // ajout timeline event start
                document.getElementById("tl_conteneur").innerHTML += `<div class="timeline-event">
                <div class="card timeline-content">
                    <div class="card-image waves-effect waves-block waves-light">
                        <img class="activator" src="https://upload.wikimedia.org/wikipedia/commons/thumb/8/8e/Big_Ben%2C_Londres%2C_Inglaterra%2C_2014-08-11%2C_DD_199.JPG/247px-Big_Ben%2C_Londres%2C_Inglaterra%2C_2014-08-11%2C_DD_199.JPG">
                    </div>
                    <div class="card-content">
                        <span class="card-title activator grey-text text-darken-4">Arrivée<i
                                class="material-icons right">directions_walk</i></span>
                        <p>Arrivée : Londres </p>
                    </div>
                </div>
                <div class="timeline-badge green white-text"><i class="material-icons">language</i></div>
            </div>`;
            }

        });

        function handlePub() {
            client.publish("fablabgsv@gmail.com/finish", "demo | go to finish it !");
            console.log("mqtt pub to finish ");
        };
    </script>
    <div class="container">
        <div class="row">
            <div class="col s12">
              <h1>LAB MQTT demo</h1>
              <h2>
                Status :
                <span id="connect-badge" class="new badge orange" data-badge-caption="">connecting</span>
              </h2>
            </div>
          </div>
        <div class="timeline" id="tl_conteneur">
        </div>
    </div>
</body>

</html>